<?php
/*
Plugin Name: Are PayPal
Plugin URI: http://arepaypal.ehibou.com/
Description: This plugin is used to monetize wordpress blog content using PayPal.
Version: 1.4.5
Author: Aurimas Norkevicius
Author URI: http://are.ehibou.com
*/
/*  Copyright 2007  Aurimas Norkevicius  (email : Aurimas.Norkevicius@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version. Provide the author with your changes to the code.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
include_once(dirname(__FILE__)."/are-paypal-configuration.php");
include_once(dirname(__FILE__)."/are-paypal-install.php");
if (!class_exists('Are_PayPal')) {
	class Are_PayPal{


		var $prefix = "Are_PayPal";

		var $paied_users_table;
		var $paied_items_table;
		var $bonus_posts_table;
		var $paypal_payment_info_table;
		var $paypal_requests_table;
		var $paypal_field_types_table;
		var $paypal_fields_table;


		var $paypal_url;
		var $paypal_email;
		var $start_delimiter;
		var $end_delimiter;
		var $delimiter_tag_name;
		var $post_type_clause = "(posts.post_type='post' OR posts.post_type='page' OR posts.post_type='')";


		function Are_PayPal(){
			global $wpdb;
			$configuration= new  Are_PayPal_Configuration();

			//Initialize properties
			$this->start_delimiter=$configuration->start_delimiter;
			$this->end_delimiter=$configuration->end_delimiter;
			$this->delimiter_tag_name=$configuration->delimiter_tag_name;
			$this->paied_users_table = $configuration->paied_users_table;
			$this->paied_items_table = $configuration->paied_items_table;
			$this->bonus_posts_table = $configuration->bonus_posts_table;
			$this->paypal_requests_table = $configuration->paypal_requests_table;
			$this->paypal_field_types_table = $configuration->paypal_field_types_table;
			$this->paypal_fields_table = $configuration->paypal_fields_table;

			$this->paypal_payment_info_table=$configuration->paypal_payment_info_table;

			$this->paypal_url=$configuration->paypal_url;
			$this->paypal_email = $configuration->paypal_email;

			//Hook into wordpress
			add_action('admin_menu', array(&$this,'Are_PayPal_Configuration'));
			add_filter('the_content', array(&$this,'post_filter'));
			add_action('wp_head', array(&$this,'add_html_headers'));
			$install = new Are_PayPal_Install();
			register_activation_hook(__FILE__,array(&$install,'install'));
		}

		function post_filter($content){
			$start_delimiter=$this->start_delimiter;
			$end_delimiter=$this->end_delimiter;
			global $current_user, $user_ID,$post_ID,$post,$id;
			$postID=$post_ID;
			$userID=$user_ID;
			if ($userID == 0) {$userID = $current_user->id;}
			if ($postID == 0) {$postID = $post->id;}
			if ($postID == 0) {$postID = $id;}
			$isPostPurchased=$this->IsPostPurchased($postID,$userID);
			$combination=((!$this->IsGooglebot())&&(($userID == 0) || (!$isPostPurchased)));
			echo("<!-- isPostPurchased $isPostPurchased,postID $postID, userID $userID, combination $combination -->");
			if ((!$this->IsGooglebot())&&(($userID == 0) || (!$isPostPurchased))){
				$start = strpos($content, $start_delimiter);
				$end = strpos($content, $end_delimiter);

				$pre = substr($content,0,$start);
				$suf = substr($content,$end,strlen($content));
				$delimiterRegex="/\\[$this->delimiter_tag_name\\].*?\\[\/$this->delimiter_tag_name\\]/is";
				if (!(($start===FALSE) && ($end===FALSE))){
					if ($userID == 0){
						$domain = $_SERVER['HTTP_HOST'];
						$url = "http://" . $domain . $_SERVER['REQUEST_URI'];
						$LoginButton="<div class='ArePayPalContent'>";
						$LoginButton.="<p class='ArePayPalTextToShowIfNotLogedIn'>".get_option($this->prefix.'_TextToShowIfNotLogedIn')."</p>";
						$LoginButton.="<a class='ArePayPalLoginButton' href='".get_option ('siteurl')."/wp-login.php?redirect_to=$url'>".__("Login")."</a>";
						$LoginButton.="</div>";
						$content = preg_replace($delimiterRegex,$LoginButton,$content);
					}else{
						global $wpdb;
						$sql="SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts INNER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$postID'";
						$items = $wpdb->get_results($sql);
						if($items) {
							$item=$items[0];
							$item_id=$item->ID;
							$item_title=$item->post_title;
							$item_amount=$item->amount;
							$item_currency=$item->currency;
							$item_name=$item->name;
							$item_number=$item->number;
							$item_expire=$this->native_expiration_message($item->expire);
							$postButton=$this->paypal_buy_now_form($item_name.":".$item_title." ".$item_expire,$item_number,$item_amount,$item_currency,$postID,$userID);
						}
						$blog_item_amount=get_option($this->prefix.'_BlogAmount');
						if ($blog_item_amount){
							$blog_item_amount=get_option($this->prefix.'_BlogAmount');
							$blog_item_currency=get_option($this->prefix.'_BlogCurrency');
							$blog_item_name=get_option($this->prefix.'_BlogName');
							$blog_item_number=get_option($this->prefix.'_BlogNumber');
							$blog_item_expire=get_option($this->prefix.'_BlogExpire');
							$blog_item_expire=$this->native_expiration_message($blog_item_expire);
							$blogButton=$this->paypal_buy_now_form($blog_item_name.":".$blog_item_title." ".$blog_item_expire,$blog_item_number,$blog_item_amount,$blog_item_currency,-1,$userID);//-1 post id for whole site
						}
						echo("<!--$blogButton  $postButton -->");
						if ($blogButton || $postButton){
							$content = preg_replace($delimiterRegex,$postButton.$blogButton,$content);
						}

					}
				}
			}
			$content= str_replace($start_delimiter,'',$content);
			$content= str_replace($end_delimiter,'',$content);
			return $content;
		}
		function native_expiration_message($item_expire){
			if ($item_expire){
				$item_expire=__(" Expires in ").$item_expire.__(" days");
			}else{
				$item_expire="";
			}
			return $item_expire;
		}
		function Are_PayPal_Configuration() {
			global $wpdb;
			if ( function_exists('add_submenu_page') ){
				add_menu_page(__($this->prefix), __($this->prefix), 10, __FILE__, array(&$this,'Main_Configuration_Page'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 2'), __('Post Prices'), 10,$this->prefix.'_PostSetup' , array(&$this,'Configure_Prices_For_Posts'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 3'), __('Paypal data'), 10,$this->prefix.'_PaypalData' , array(&$this,'View_Payments'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 4'), __('Blog Price'), 10,$this->prefix.'_BlogPrice' , array(&$this,'Blog_Price'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 5'), __('How to use'), 10,$this->prefix.'_HowToUse' , array(&$this,'How_To_Use'));
			}
		}

		function Main_Configuration_Page() {
			if ( isset($_POST['submit']) ) {
				check_admin_referer();

				$Value = $_POST['TextToShowIfNotLogedIn'];
				update_option($this->prefix.'_TextToShowIfNotLogedIn', $Value);

				$Value = $_POST['PayPal_Email'];
				update_option($this->prefix.'_PayPal_Email', $Value);

				$Value = $_POST['test'];
				update_option($this->prefix.'_test', $Value);

				$Value = $_POST['TextToShowIfNotPurchased'];
				update_option($this->prefix.'_TextToShowIfNotPurchased', $Value);
				$LastAction = __("Updated successfully ...");
			}
			?>
			<?php if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e($this->prefix.' Configuration'); ?></h2>
				<p><?php printf(__('<a href="http://are.ehibou.com/">Aurimas Norkevicius</a> for help with the plugin.')); ?></p>
				<form action="" method="post" id="<?=$this->prefix?>-conf" style="margin: auto; width: 25em; ">
					<h3><label for="TextToShowIfNotLogedIn"><?php _e('Text to show if visitor is not logged in'); ?></label></h3>
					<p><textarea id="TextToShowIfNotLogedIn" name="TextToShowIfNotLogedIn" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;"><?php echo stripslashes(get_option($this->prefix.'_TextToShowIfNotLogedIn')); ?></textarea> 
					<h3><label for="TextToShowIfNotPurchased"><?php _e('Text to show if content is not purchased by a visitor'); ?></label></h3>
					<p><textarea id="TextToShowIfNotPurchased" name="TextToShowIfNotPurchased" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;"><?php echo stripslashes(get_option($this->prefix.'_TextToShowIfNotPurchased')); ?></textarea> 
					<p><input id="test" name="test" type="checkbox" value="checked" <?php echo get_option($this->prefix.'_test'); ?> />&nbsp;&nbsp;<label for="test"><?php _e('<a href="http://developer.paypal.com" target=_blank>Use PayPal Sandbox</a> (testing only)'); ?></label></p>
					
					<h3><label for="PayPal_Email"><?php _e('PayPal email'); ?></label></h3>
					<p><input id="PayPal_Email" name="PayPal_Email" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;" value="<?=stripslashes(get_option($this->prefix.'_PayPal_Email')); ?>"/></p>

					<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Options&raquo;'); ?>" /></p>
				</form>
			</div>
			<?php
		}
		function How_To_Use(){
			?>
			<div class="wrap">
				<h2><?php _e('How to use'); ?></h2>
				<p><strong>How to hide content and show paypal button?</strong></p>
				<p>
					<ul>
						<li>Use pseudo tags '<?=$this->start_delimiter;?>' and '<?=$this->end_delimiter;?>' to mark hidden/payed content.</li>
						<li>Goto configuration section and enter a price for a post.</li>
					</ul>
				</p>
				<p><strong>How to configure paypal's Instant Payment Notification (IPN)?</strong></p>
				<p>
					<ul>
						<li>Follow the <a href="<?=$this->paypal_url?>?cmd=_profile-ipn-notify">link</a></li>
						<li>Set IPN "On"</li>
						<li>Set IPN Url to '<?=get_option("home")?>/wp-content/plugins/are-paypal/are-paypal-ipn.php'</li>
					</ul>
				</p>
			</div>
			<?
		}
		function Blog_Price() {
			if ( isset($_POST['submit']) ) {
				check_admin_referer();

				$Value=$_POST["amount"];
				update_option($this->prefix.'_BlogAmount', $Value);
				$Value=$_POST["currency"];
				update_option($this->prefix.'_BlogCurrency', $Value);
				$Value=$_POST["name"];
				update_option($this->prefix.'_BlogName', $Value);
				$Value=$_POST["number"];
				update_option($this->prefix.'_BlogNumber', $Value);
				$Value=$_POST["expire"];
				update_option($this->prefix.'_BlogExpire', $Value);
				$LastAction = __(" Updated successfully ...");
			}
			if ( isset($_POST['clear']) ) {
				check_admin_referer();

				delete_option($this->prefix.'_BlogAmount');
				delete_option($this->prefix.'_BlogCurrency');
				delete_option($this->prefix.'_BlogName');
				delete_option($this->prefix.'_BlogNumber');
				delete_option($this->prefix.'_BlogExpire');
				$LastAction = __(" Deleted successfully ...");

			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			$item_currency=get_option($this->prefix.'_BlogCurrency');
			$item_name=get_option($this->prefix.'_BlogName');
			$item_number=get_option($this->prefix.'_BlogNumber');
			$item_expire=get_option($this->prefix.'_BlogExpire');
			?>
			<?php if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e('Edit Blog Price'); ?></h2>
				<form method="post" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<table width="100%"  border="0" cellspacing="3" cellpadding="3">
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Name'); ?></td>
						<td><input type="text" name="name" value="<?=$item_name?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Number'); ?></td>
						<td><input type="text" name="number" value="<?=$item_number?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Price'); ?></td>
						<td><input type="text" name="amount" value="<?=$item_amount?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Currency'); ?></td>
						<td><input type="text" name="currency" value="<?=$item_currency?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Expire (period in days)'); ?></td>
						<td><input type="text" name="expire" value="<?=$item_expire?>"/></td>
					</tr>
				</table>
				<p class="submit"><input type="submit" name="submit" value="Submit&raquo;"/></p>
				<p class="submit"><input type="submit" name="clear" value="Delete&raquo;"/></p>
				</form>
			</div>
			<?php
		}

		function View_Payments() {
			global $wpdb;
			$payments=$wpdb->get_results("select * from $this->paypal_payment_info_table",ARRAY_A);
			if(count($payments) > 0) {
				$firstRow=$payments[0];
				$columnNames=array_keys($firstRow);
				?>
			<div class="wrap">
<!-- Manage Post Prices -->
	<h2><?php _e('View Payments'); ?></h2>
	<table width="100%"  border="0" cellspacing="3" cellpadding="3">
	<?php
	?>
	<?
	foreach($payments as $row) {
		?>
		<tr><td>
		<table width="100%"  border="0" cellspacing="3" cellpadding="3" style="border-width:1px;border-color:black;">
		<?
		$this->Arrange_dataInto_Lines($columnNames,$row,4);
		?>
		</table>
		</td></tr>
		<?
	}
	?>
	</table>
	</div>
	<?
			}
		}
		function Arrange_dataInto_Lines($columnNames,$row,$number_of_rows,$current_row=0){
			if ($number_of_rows>$current_row){
					?>
					<tr>
					<?
					$counter=0;
					foreach($columnNames as $columnName) {
						$counter++;
						if ($counter % $number_of_rows==$current_row){
							?><th><? _e($columnName)?></td><?
						}
					}
					?>
					</tr>
					<tr>
					<?
					$counter=0;
					foreach($columnNames as $columnName) {
						$counter++;
						if ($counter % $number_of_rows==$current_row){
							?><td><?=$row[$columnName]?></td><?
						}
					}
					?>
					</tr>
					<?			
					$this->Arrange_dataInto_Lines($columnNames,$row,$number_of_rows,$current_row+1);
			}
		}
		function Configure_Prices_For_Posts() {
			global $wpdb;
			### Get The Posts
			$action = mysql_escape_string($_GET["action"]);
			$post_id = mysql_escape_string($_GET["post_id"]);
			if ($_GET["BonusSubmit"]){
				if ($_GET["BonusSubmit"]==">>"){
					$post2_id=$_GET["post_to_package"];
					$wpdb->query("INSERT INTO $this->bonus_posts_table VALUES($post_id,$post2_id)");
					$wpdb->query("INSERT INTO $this->bonus_posts_table VALUES($post2_id,$post_id)");
					$LastAction = __("Added successfully ...");
				}else{
					$post2_id=$_GET["post_in_package"];
					$wpdb->query("DELETE FROM $this->bonus_posts_table WHERE post1_id=$post_id AND post2_id=$post2_id");
					$wpdb->query("DELETE FROM $this->bonus_posts_table WHERE post1_id=$post2_id AND post2_id=$post_id");
					$LastAction = __("Removed successfully ...");
				}
			}

			if ($_GET["PurchasersSubmit"]){
				if ($_GET["PurchasersSubmit"]==">>"){
					$item_purchaser=$_GET["available_users"];
					$wpdb->query("INSERT INTO $this->paied_users_table(post_id,user_id) VALUES($post_id,$item_purchaser)");
					$LastAction = __("Added successfully ...");
				}else{
					$item_purchaser=$_GET["paied_users"];
					$wpdb->query("DELETE FROM $this->paied_users_table WHERE post_id=$post_id AND user_id=$item_purchaser");
					$LastAction = __("Removed successfully ...");
				}
			}

			if (($action=="delete")&&($post_id)){
				$wpdb->query("DELETE FROM $this->paied_items_table WHERE post_id=$post_id");
				$wpdb->query("DELETE FROM $this->paied_users_table WHERE post_id=$post_id");
				$LastAction = __("Deleted successfully ...");
			}
			if (($action=="write")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id'");
				$item=$items[0];
				$item_id=$item->ID;
				$item_amount=mysql_escape_string($_GET["amount"]);
				$item_currency=mysql_escape_string($_GET["currency"]);
				$item_name=mysql_escape_string($_GET["name"]);
				$item_number=mysql_escape_string($_GET["number"]);
				$item_expire=$_GET["expire"];
				if ($item->post_id){
					//UPDATE
					$sql="UPDATE $this->paied_items_table SET name='$item_name',number='$item_number',amount='$item_amount',currency='$item_currency',expire='$item_expire' WHERE post_id=$item_id";
					$LastAction = __("Updated successfully ...");
				}else{
					//INSERT
					$sql="INSERT INTO $this->paied_items_table (name,number,amount,currency, post_id,expire) VALUES('$item_name','$item_number','$item_amount','$item_currency','$item_id','$item_expire')";
					$LastAction = __("Inserted successfully ...");
				}
				$wpdb->query($sql);
			}
			if (($action=="purchasers")&&($post_id)){
				if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; }
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title FROM $wpdb->posts posts WHERE posts.id='$post_id'");
				if($items) {
					$item=$items[0];
					$item_id=$item->ID;
					$item_title=$item->post_title;
				?>
			<div class="wrap">
				<h2><?php _e('Post purchasers'); ?></h2>
				<form method="get" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="purchasers"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$post_id?>"/>
						<table>
						<tr><th colspan="3"><strong><?php _e('Post: '); ?><?=$item_title?></strong></th></tr>
						<tr>
							<th><?php _e('Available users'); ?></th>
							<th>&#160;</th>
							<th><?php _e('Paied users'); ?></th>
						</tr>
						<tr>
						<td>
						<select multiple="false" name="available_users" size="10" style="width:200px;height:200px;">
						<?
						$users = $wpdb->get_results("SELECT u.id,user_login FROM $wpdb->users u WHERE u.id not in (SELECT user_id FROM $this->paied_users_table WHERE post_id=$item_id AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0))");
						if ($users){
							foreach($users as $user) {
								?><option value="<?=$user->id;?>"><?=$user->user_login;?></option><?
							}
						}
						?>
						</select>
						</td>
						<td>
						<p class="submit" style="border-top:0;"><input type="submit" name="PurchasersSubmit" value=">>"/></p><p class="submit" style="border-top:0;"><input name="PurchasersSubmit" type="submit" value="<<"/></p>
						</td>
						<td>
						<select multiple="false" name="paied_users" size="10" style="width:200px;height:200px;">
						<?
						$users = $wpdb->get_results("SELECT u.id,user_login FROM $wpdb->users u INNER JOIN $this->paied_users_table up ON up.user_id=u.id and up.post_id=$item_id AND (ADDDATE(up.purchase_date, up.expire) > CURDATE() OR up.expire is null OR up.expire = 0)");
						if ($users){
							foreach($users as $user) {
								?><option value="<?=$user->id;?>" selected="true"><?=$user->user_login;?></option><?
							}
						}
						?>
						</select>
						</td>
						</tr>
						</table>
						</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="edit"/>
				<input type="hidden" name="post_id" value="<?=$post_id;?>"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<p class="submit"><input type="submit" value="Cancel&raquo;"/></p>
				</form>
<?
				}
			}elseif (($action=="bonus")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id' AND $this->post_type_clause");
				if($items) {
					$item=$items[0];
					$item_id=$item->ID;
					$item_title=$item->post_title;
					$item_amount=$item->amount;
					$item_currency=$item->currency;
					$item_expire=$item->expire;
					$item_name=$item->name;
					$item_number=$item->number;
if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
<div class="wrap">
				<h2><?php _e('Bonus posts'); ?></h2>
				<form method="get" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="bonus"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
						<table>
						<tr><th colspan="3"><strong><?php _e('Post: '); ?><?=$item_title?></strong></th></tr>
						<tr>
							<th><?php _e('Available posts'); ?></th>
							<th>&#160;</th>
							<th><?php _e('Bonus posts'); ?></th>
						</tr>
						<tr>
						<td>
						<select multiple="false" name="post_to_package" size="10" style="width:200px;height:200px;">
						<?
						$posts_to_package=$wpdb->get_results("SELECT posts.* FROM $wpdb->posts posts WHERE posts.id!=$item_id AND  posts.post_content LIKE '%$this->start_delimiter%'AND $this->post_type_clause AND posts.id NOT IN(select post2_id from $this->bonus_posts_table WHERE post1_id='$item_id')");
						if ($posts_to_package){
							foreach($posts_to_package as $post_to_package) {
								?><option value="<?=$post_to_package->ID;?>"><?=$post_to_package->post_title;?></option><?
							}
						}
						?>
						</select>
						</td>
						<td>
						<p class="submit" style="border-top:0;"><input type="submit" name="BonusSubmit" value=">>"/></p><p class="submit" style="border-top:0;"><input name="BonusSubmit" type="submit" value="<<"/></p>
						</td>
						<td>
						<select multiple="false" name="post_in_package" size="10" style="width:200px;height:200px;">
						<?
						$posts_in_package=$wpdb->get_results("SELECT posts.* FROM $wpdb->posts posts WHERE posts.id!=$item_id AND posts.post_content LIKE '%$this->start_delimiter%' AND $this->post_type_clause AND posts.id IN(select post2_id from $this->bonus_posts_table WHERE post1_id='$item_id')");
						if ($posts_in_package){
							foreach($posts_in_package as $post_in_package) {
								?><option value="<?=$post_in_package->ID;?>"><?=$post_in_package->post_title;?></option><?
							}
						}
						?>
						</select>
						</td>
						</tr>
						</table>
						</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="list"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<p class="submit"><input type="submit" value="Cancel&raquo;"/></p>
				</form>
						<?
				}
			}else if (($action=="edit")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id'");
				if($items) {
					$item=$items[0];
					$item_id=$item->ID;
					$item_title=$item->post_title;
					$item_amount=$item->amount;
					$item_currency=$item->currency;
					$item_expire=$item->expire;
					$item_name=$item->name;
					$item_number=$item->number;
				?>
			<? if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e('Edit Post Price'); ?></h2>
				<form method="get" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="write"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
				<table width="100%"  border="0" cellspacing="3" cellpadding="3">
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('ID'); ?></td>
						<td><?=$item_id?></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Post Title'); ?></td>
						<td><?=$item_title?></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Name'); ?></td>
						<td><input type="text" name="name" value="<?=$item_name?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Number'); ?></td>
						<td><input type="text" name="number" value="<?=$item_number?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Price'); ?></td>
						<td><input type="text" name="amount" value="<?=$item_amount?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Currency'); ?></td>
						<td><input type="text" name="currency" value="<?=$item_currency?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Expire (period in days)'); ?></td>
						<td><input type="text" name="expire" value="<?=$item_expire?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Purchasers'); ?></td>
						<td>
						<?
						$users = $wpdb->get_results("SELECT user_login FROM $wpdb->users u INNER JOIN $this->paied_users_table up ON up.user_id=u.id and up.post_id=$item_id AND (ADDDATE(up.purchase_date, up.expire) > CURDATE() OR up.expire is null OR up.expire = 0)");
						foreach($users as $user) {
							echo $user->user_login;
							echo "<br/>";
						}
						?>
						<a href="?page=<?=$this->prefix.'_PostSetup'?>&action=purchasers&post_id=<?=$post_id?>"><?=_e('Edit purchasers')?></a>
						</td>
					</tr>
				</table>
				<p class="submit"><input type="submit" value="Submit&raquo;"/></p>
				</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="delete"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
				<p class="submit"><input type="submit" value="Clear Priceing&raquo;"/></p>
				</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="list"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<p class="submit"><input type="submit" value="Cancel&raquo;"/></p>
				</form>
				<?
				}
			}else{
				$sql="SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.post_content LIKE '%$this->start_delimiter%' AND $this->post_type_clause";
				$items = $wpdb->get_results($sql);
 if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
<!-- Manage Post Prices -->
	<h2><?php _e('Post Prices'); ?></h2>
	<table width="100%"  border="0" cellspacing="3" cellpadding="3">
	<tr>
		<th width="2%"><?php _e('ID'); ?></th>
		<th width="28%"><?php _e('Post Title'); ?></th>
		<th width="28%"><?php _e('Purchasers'); ?></th>
		<th width="28%"><?php _e('Name'); ?></th>
		<th width="28%"><?php _e('Number'); ?></th>
		<th width="28%"><?php _e('Price'); ?></th>
		<th width="28%"><?php _e('Currency'); ?></th>
		<th width="28%"><?php _e('Expire (period in days)'); ?></th>
		<th width="28%">&nbsp;</th>
	</tr>
	<?php
	if($items) {
		$i = 0;
		foreach($items as $item) {
			if($i%2 == 0) {
				$style = 'style=\'background-color: #eee\'';
			}  else {
				$style = 'style=\'background-color: none\'';
			}
			$item_id=$item->ID;
			$item_title=$item->post_title;
			$item_amount=$item->amount;
			$item_currency=$item->currency;
			$item_expire=$item->expire;
			$item_name=$item->name;
			$item_number=$item->number;
			echo "<tr $style>\n";
			echo "<td>$item_id</td>\n";
			echo "<td>$item_title</td>\n";
			echo "<td>";
			$users = $wpdb->get_results("SELECT user_login FROM $wpdb->users u INNER JOIN $this->paied_users_table up ON up.user_id=u.id and up.post_id=$item_id AND (ADDDATE(up.purchase_date, up.expire) > CURDATE() OR up.expire is null OR up.expire = 0)");
			foreach($users as $user) {
				echo $user->user_login;
				echo "<br/>";
			}
			echo "</td>\n";
			echo "<td>$item_name</td>\n";
			echo "<td>$item_number</td>\n";
			echo "<td>$item_amount</td>\n";
			echo "<td>$item_currency</td>\n";
			echo "<td>$item_expire</td>\n";
				?>
				<td nowrap>
					<?
					if ($item->post_id){
						?><a href="?page=<?=$this->prefix.'_PostSetup'?>&action=delete&post_id=<?=$item_id?>"><?=_e('Clear Priceing')?></a> | <?
						?><a href="?page=<?=$this->prefix.'_PostSetup'?>&action=bonus&post_id=<?=$item_id?>"><?=_e('Edit bonus posts')?></a> | <?
					}
					?>
					<a href="?page=<?=$this->prefix.'_PostSetup'?>&action=edit&post_id=<?=$item_id?>"><?=_e('Edit')?></a>
				</td>
				<?
				echo '</tr>';
				$i++;
		}
	} else {
		echo '<tr><td colspan="2" align="center"><b>'.__('No Posts Found').'</b></td></tr>';
	}
	?>
	</table>
<?}?>
</div>
<?
		}
		function IsGooglebot(){
			// check if user agent contains googlebot
			if(eregi("Googlebot",$_SERVER['HTTP_USER_AGENT'])){
				$ip = $_SERVER['REMOTE_ADDR'];
				//server name e.g. crawl-66-249-66-1.googlebot.com
				$name = gethostbyaddr($ip);
				//check if name ciontains googlebot
				if(eregi("Googlebot",$name)){
					//list of IP's
					$hosts = gethostbynamel($name);
					foreach($hosts as $host){
						if ($host == $ip){
							return true;
						}
					}
					return false; // Pretender, take some action if needed
				}else{
					return false; // Pretender, take some action if needed
				}
			}else{
				// Not googlebot, take some action if needed
			}
			return false;
		}
		function IsPostPurchased($post_id,$user_id){
			$user_id=mysql_escape_string($user_id);
			$post_id_tmp=$post_id;
			$post_id="-1";
			global $wpdb;
			$sql="SELECT users.* FROM . $this->paied_users_table users WHERE (users.post_id='$post_id') AND users.user_id='$user_id' AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0)";
			$users = $wpdb->get_results($sql);
			if ($users){
				return true;
			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			if ($item_amount){
				$sql="SELECT * FROM .$this->paypal_payment_info_table WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount";
				$paypal_response=$wpdb->get_results($sql);
				if ($paypal_response){
					//Grant access(This is needed to prevent misfunction on price change)
					$this->PayForItem($post_id,$user_id);
					$wpdb->query("UPDATE $this->paypal_payment_info_table SET custom='[processed]$post_id|$user_id' WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
					return true;
				}
			}

			$post_id=mysql_escape_string($post_id_tmp);
			$sql = "SELECT items.* FROM $this->paied_items_table items WHERE items.post_id='$post_id'";
			$items = $wpdb->get_results($sql);
			if($items) {
				$sql="SELECT users.* FROM . $this->paied_users_table users WHERE (users.post_id='$post_id') AND users.user_id='$user_id' AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0)";
				$users = $wpdb->get_results($sql);
				if ($users){
					return true;
				}
				$item_amount=$items[0]->amount;
				if ($item_amount){

					$paypal_response=$wpdb->get_results("SELECT * FROM .$this->paypal_payment_info_table WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
					if ($paypal_response){
						//Grant access(This is needed to prevent misfunction on price change)
						$this->PayForItem($post_id,$user_id);
						$wpdb->query("UPDATE $this->paypal_payment_info_table SET custom='[processed]$post_id|$user_id' WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
						return true;
					}
				}

			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			if ($item_amount){
				return false;
			}
			return false;
		}
		// Create User administration screen
		function PayForItem($post_id,$user_id){
			global $wpdb;
			$post_id=mysql_escape_string($post_id);
			$items = $wpdb->get_results("SELECT * FROM . $this->paied_items_table WHERE post_id='$post_id'");
			$expire='';
			if ($items){
				$expire=$items[0]->expire;
			}
			if ($post_id=="-1"){
				$expire=get_option($this->prefix.'_BlogExpire');
			}
			$user_id=mysql_escape_string($user_id);
			$users = $wpdb->get_results("SELECT users.* FROM . $this->paied_users_table users WHERE users.post_id='$post_id' AND users.user_id='$user_id' AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0)");
			if (!$users){
				$wpdb->query("INSERT INTO $this->paied_users_table(post_id,user_id,expire) VALUES('$post_id','$user_id','$expire')");
				$bonuses = $wpdb->get_results("SELECT post2_id FROM . $this->bonus_posts_table WHERE post1_id='$post_id'");
				foreach($bonuses as $bonus) {
					$this->PayForItem($bonus->post2_id,$user_id);
				}
			}
		}
		function paypal_buy_now_form($item_name,$item_number,$item_price,$item_currency,$post_id,$user_id){
			$paypal_url=$this->paypal_url;
			$paypal_email = $this->paypal_email;
			$item_custom = $post_id."|".$user_id;
			$domain = $_SERVER['HTTP_HOST'];
			$item_return = "http://" . $domain . $_SERVER['REQUEST_URI'];
			$textExplanation ="<p class='ArePayPalTextToShowIfNotPurchased'>".get_option($this->prefix.'_TextToShowIfNotPurchased')."</p>";
			$result="
		<div class='ArePayPalContent'>".$textExplanation."
		<form action='$paypal_url' method='post'>
		    <p class='ArePayPalContentTitle'>$item_name: $item_number</p>
		    <p class='ArePayPalContentPrice'>$item_price $item_currency</p>
			<p class='ArePayPalBonusList'>".$this->BonusPostsList($post_id)."</p>
			<input type='hidden' name='cmd' value='_xclick'/>
			<input type='hidden' name='business' value='$paypal_email'/>
			<input type='hidden' name='item_name' value='$item_name'/>
			<input type='hidden' name='item_number' value='$item_number'/>
			<input type='hidden' name='amount' value='$item_price'/>
			<input type='hidden' name='no_shipping' value='1'/>
			<input type='hidden' name='no_note' value='1'/>
			<input type='hidden' name='return' value='$item_return'>
			<input type='hidden' name='custom' value='$item_custom'/>
			<input type='hidden' name='currency_code' value='$item_currency'/>
			<input type='hidden' name='bn' value='IC_ArePayPal'/>
			<input type='image' src='https://www.paypal.com/en_US/i/btn/x-click-butcc.gif' name='submit' alt='Make payments with payPal - it\'s fast, free and secure!'/>
			<img alt='' src='https://www.paypal.com/en_US/i/scr/pixel.gif' width='1' height='1'/>
		</form>
		</div>
		";
			return $result;
		}
		function BonusPostsList($post_id){
			global $wpdb;
			$post_id=mysql_escape_string($post_id);
			$sql="select posts.post_title,posts.id from $this->bonus_posts_table bonuses INNER JOIN $wpdb->posts posts ON posts.id=bonuses.post2_id WHERE bonuses.post1_id='$post_id'";
			$bonuses=$wpdb->get_results($sql);
			$result="";
			if ($bonuses){
				$result.="<p>".__("Purchasing current content you will also get access for posts below")."</p><ul>";
				foreach($bonuses as $bonus) {
					$result.="<li><a href='?p=$bonus->id'>$bonus->post_title</a></li>";
				}
				$result.="</ul>";
			}
			return $result;
		}
		function add_html_headers(){
			echo('<META NAME="ROBOTS" CONTENT="NOARCHIVE"/>');
			echo('<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/are-paypal/are-paypal.css" />');
		}
	}
}
//instantiate the class
if (class_exists('Are_PayPal')) {
	$Are_PayPal = new Are_PayPal();
}

?>
